routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ChildrenController;
use App\Http\Controllers\UserManagementController;
use App\Http\Controllers\GroupLearnersController;
use App\Http\Controllers\PersonController;
use App\Http\Controllers\ParentController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::view('/', 'welcome', ["message" => "Hello!"]);

Route::middleware(['auth'])->group(function () {
    Route::prefix('profile')->group(
        function () {
            Route::get('/', [UserController::class, 'profile'])->name('profile');
            Route::post('/update', [UserController::class, 'update'])->name('profile.update');
        }
    );

    Route::resource('persons', PersonController::class);
    Route::resource('children', ChildrenController::class);
    Route::resource('parents', ParentController::class);
});

Route::middleware(['auth', 'admin.check'])->group(function () {
    Route::prefix('management')->group(
        function () {
            Route::resource('users', UserManagementController::class);
        }
    );
});

Route::middleware(['auth', 'employee.check'])->group(function () {
    Route::prefix('management')->group(
        function () {
            Route::resource('groupslearners', GroupLearnersController::class);
        }
    );
});

Auth::routes();


require __DIR__.'/auth.php';

app/Models/Family.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Person;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\SoftDeletes;

class Family extends Model
{
    use HasFactory;
    use SoftDeletes;

    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'family';

    protected $fillable = ['name'];

    public function persons()
    {
        return $this->hasMany(Person::class, 'family_id', 'id');
    }

    public function getCreatedAtAttribute($value)
    {
        return Carbon::parse($value)->format("Y-m-d");
    }
}

app/Http/Controllers/ParentController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Services\FamilyService;
use App\Services\ParentService;
use App\Http\Requests\PersonUpdateRequest;
use App\Models\Person;
use App\Http\Requests\PersonStoreRequest;
use Illuminate\Support\Facades\Auth;

class ParentController extends Controller
{
    public function __construct(ParentService $parents, FamilyService $family)
    {
        $this->parents = $parents;
        $this->family = $family;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view(
            'parent.index',
            ["parents" => $this->parents->getByFamily(Auth::user()),]
        );
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $user = Auth::user();
        if (empty($user->person_id)) {
            $name = $user->name;
        }else{
            $name = "";
        }

        return view(
            'parent.create',
            [
                "name" => $name
            ]
        );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(PersonStoreRequest $request)
    {
        $user = Auth::user();
        $person = $this->parents->createWithFamily($request->all(),$user);
        return redirect()->route('parents.show', ["parent"=>$person->id])->withSuccess(
           'Особу '. $person->name . " було створено!"
        );
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return view(
            'parent.show',
            ["parent" => $this->parents->findById($id)]
        );
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view(
            'parent.edit',
            [
                "parent" => $this->parents->findById($id),
                "family" => $this->parents->getByFamily(Auth::user())
            ]
        );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(PersonUpdateRequest $request, Person $parent)
    {
        $this->parents->update($parent->id, $request->except(['_method', '_token']));
        return redirect()->route('parents.show', ["parent" => $parent->id])->withSuccess(
            'Інформацію #' . $parent->id . " оновлено!"
        );
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $this->parents->destroy($id);
        return redirect()->route('parents.index')->withSuccess('Дані про особу #' . $id . " були видалені!");
    }
}

resources/views/parent/create.blade.php
@extends('adminlte::page')

@section('content')
    <form method="POST" action="{{ route('parents.store') }}">
        @csrf
        <div class="row">
            <div class="col-md-12">
                <div class="card card-primary">
                    <div class="card-header">
                        <h3 class="card-title">Додавання рідних</h3>

                        <div class="card-tools">
                            <button type="button" class="btn btn-tool" data-card-widget="collapse" data-toggle="tooltip"
                                    title="Collapse">
                                <i class="fas fa-minus"></i></button>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="form-group">
                            <label for="inputName">Ім'я</label>
                            <input type="text" name="name" id="inputName" class="form-control @error('name') is-invalid @enderror" value="{{old('name') ?? $name }}">
                            @error('name')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="inputSurname">Прізвище</label>
                            <input type="text" name="surname" id="inputSurname" class="form-control @error('surname') is-invalid @enderror" value="{{old('surname') ?? '' }}">
                            @error('surname')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="inputMiddleName">Ім'я по батькові</label>
                            <input type="text" name="middle_name" id="inputMiddleName" class="form-control @error('middle_name') is-invalid @enderror" value="{{old('middle_name') ?? '' }}">
                            @error('middle_name')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>

                        <div class="form-group">
                            <label for="inputSex">Стать</label>
                            <select class="form-control" name="sex">
                                <option value="female" id="inputSex" class="form-control @error('sex') is-invalid @enderror" value="{{old('sex') ?? '' }}">Чоловік</option>
                                <option value="male" id="inputSex" class="form-control @error('sex') is-invalid @enderror" value="{{old('sex') ?? '' }}">Жінка</option>
                            </select>
                            @error('sex')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>

                        <div class="form-group">
                            <label for="birthday">День народження</label>
                            <input type="date" name="birthday" id="birthday" class="form-control @error('birthday') is-invalid @enderror" value="{{old('birthday')}}">
                            @error('birthday')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>

{{--                        <div class="form-group">--}}
{{--                            <label for="inputStatus">family</label>--}}
{{--                            <select name="family_id" class="form-control custom-select @error('family_id') is-invalid @enderror">--}}
{{--                                @foreach($families as $family)--}}
{{--                                    <option @if(old('family_id') && $family->id == old('family_id'))--}}
{{--                                            selected--}}
{{--                                            @endif--}}
{{--                                            value="{{ $family->id }}">{{ $family->name }}</option>--}}
{{--                                @endforeach--}}
{{--                            </select>--}}
{{--                            @error('family_id')--}}
{{--                            <span class="invalid-feedback" role="alert">--}}
{{--                                <strong>{{ $message }}</strong>--}}
{{--                            </span>--}}
{{--                            @enderror--}}
{{--                        </div>--}}
                    </div>

                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <a href="#" class="btn btn-secondary">Cancel</a>
                <input type="submit" value="Create" class="btn btn-success float-right">
            </div>
        </div>
    </form>
@stop

@section('js')
@stop

resources/views/parent/edit.blade.php
@extends('adminlte::page')

@section('content')
    <form method="POST" action="{{ route('parents.update', ["parent" => $parent->id]) }}">
        @method('PUT')
        @csrf
        <div class="row">
            <div class="col-md-12">
                <div class="card card-primary">
                    <div class="card-header">
                        <h3 class="card-title">Інформація про людину</h3>

                        <div class="card-tools">
                            <button type="button" class="btn btn-tool" data-card-widget="collapse" data-toggle="tooltip"
                                    title="Collapse">
                                <i class="fas fa-minus"></i></button>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="form-group">
                            <label for="inputName">Ім'я</label>
                            <input type="text" name="name" id="inputName" class="form-control @error('name') is-invalid @enderror" value="{{old('name') ?? $parent->name }}">
                            @error('name')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="inputSurname">Прізвище</label>
                            <input type="text" name="surname" id="inputSurname" class="form-control @error('surname') is-invalid @enderror" value="{{old('surname') ?? $parent->surname }}">
                            @error('surname')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="inputMiddleName">Ім'я по батькові</label>
                            <input type="text" name="middle_name" id="inputMiddleName" class="form-control @error('middle_name') is-invalid @enderror" value="{{old('middle_name') ?? $parent->middle_name }}">
                            @error('middle_name')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>

                        <div class="form-group">
                            <label for="inputSex">Стать</label>
                            <select class="form-control">
                                <option value="female" name="sex" id="inputSex" class="form-control @error('sex') is-invalid @enderror" value="{{old('sex') ?? '' }}" @if($parent->sex === 'male') selected @endif>Чоловік</option>
                                <option value="male"  name="sex" id="inputSex" class="form-control @error('sex') is-invalid @enderror" value="{{old('sex') ?? '' }}" @if($parent->sex === 'female') selected @endif>Жінка</option>
                            </select>
                            @error('sex')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>

                        <div class="form-group">
                            <label for="birthday">День народження</label>
                            <input type="date" name="birthday" id="birthday" class="form-control @error('birthday') is-invalid @enderror" value="{{old('birthday') ?? $parent->birthday}}">
                            @error('birthday')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
{{--                        <div class="form-group">--}}
{{--                            <label for="inputStatus">Family</label>--}}
{{--                            <select name="family_id" class="form-control custom-select @error('family_id') is-invalid @enderror">--}}
{{--                                @foreach($families as $family)--}}
{{--                                    <option @if(old('family_id') && $family->id == old('family_id'))--}}
{{--                                            selected--}}
{{--                                            @elseif( empty(old('family_id')) && $family->id === $parent->family->id)--}}
{{--                                            selected--}}
{{--                                            @endif--}}
{{--                                            value="{{ $family->id }}">{{ $family->name }}</option>--}}
{{--                                @endforeach--}}
{{--                            </select>--}}
{{--                            @error('family_id')--}}
{{--                            <span class="invalid-feedback" role="alert">--}}
{{--                                <strong>{{ $message }}</strong>--}}
{{--                            </span>--}}
{{--                            @enderror--}}
{{--                        </div>--}}
                    </div>

                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <a href="#" class="btn btn-secondary">Cancel</a>
                <input type="submit" value="Save Changes" class="btn btn-success float-right">
            </div>
        </div>
    </form>
@stop

@section('js')
@stop

resources/views/parent/index.blade.php
@extends('adminlte::page')

@section('content')
    <div class="row">
        @include('partials.alerts')
        <table id="parents" class="table table-bordered table-hover dataTable" role="grid"
               aria-describedby="example2_info">
            <thead>
            <tr role="row">
                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">Фото
                </th>
                <th class="sorting_asc" tabindex="0" aria-controls="example2" rowspan="1" colspan="1"
                    aria-sort="ascending">Ім'я
                </th>
                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">Прізвище
                </th>
                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">Ім'я по батькові
                </th>
                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">Стать
                </th>

                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">День народження
                </th>
                <th class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1">Дії
                </th>
            </tr>
            </thead>
            <tbody>
            @foreach($parents as $parent)
                <tr role="row">
                    <td>{{ $parent->img }}</td>
                    <td>{{ $parent->name }}</td>
                    <td>{{ $parent->surname }}</td>
                    <td>{{ $parent->middle_name }}</td>
                    <td>{{ (($parent->sex=='male')? 'Чоловік ' : 'Жінка ') }}</td>
                    <td>{{ $parent->birthday }}</td>
                    <td>
                        <table>
                            <a class="btn btn-primary btn-sm" href="{{ route('parents.show', ["parent" => $parent->id]) }}">
                                <i class="far fa-eye">
                                </i>
                            </a>&ensp;
                            <a class="btn btn-info btn-sm" href="{{ route('parents.edit', ["parent" => $parent->id]) }}">
                                <i class="fas fa-pencil-alt">
                                </i>
                            </a>&ensp;
                            <form method="POST" action="{{ route('parents.destroy', ["parent" => $parent->id]) }}">
                                @method('DELETE')
                                @csrf
                                <button type="submit" class="btn btn-danger btn-sm">
                                    <i class="fas fa-trash">
                                    </i>
                                </button>
                            </form>
                        </table>
                    </td>
                </tr>
            @endforeach
            </tbody>
            <tfoot>
        </table>
    </div>
@stop

@section('js')
    <script>
        $(function () {
            $('#parents').DataTable({
                "paging":       true,
                "lengthChange": false,
                "searching":    true,
                "ordering":     true,
                "info":         true,
                "autoWidth":    false,
                "language": {
                    "infoFiltered":   "(Відфільтровано _MAX_ записів)",
                    "zeroRecords":    "Записів не знайдено",
                    "info": "Показано з _START_ по _END_ записів з _TOTAL_",
                    "lengthMenu": "Показувати _MENU_ записів на сторінці",
                    "infoEmpty": "Немає записів.",
                    "search": "Пошук:",
                    "paginate": {
                        "first": "Перша",
                        "previous": "&laquo; Назад",
                        "last": "Остання",
                        "next": "Далі &raquo;"
                    }
                },
            });
        });
    </script>
@stop

resources/views/parent/show.blade.php
@extends('adminlte::page')

@section('content')
    <div class="row">
        @include('partials.alerts')
        <div class="col-md-12">
            <div class="card">
                <div class="card-body box-profile">
                    <div class="text-center">
                        <img class="profile-user-img img-fluid" src="{{ $parent->image }}" alt="Person picture">
                    </div>

                    <h3 class="profile-username text-center">#{{ $parent->id }} {{ $parent->name }}</h3>

                    <p class="text-muted text-center">{{ $parent->family }}</p>

                    <ul class="list-group list-group-unbordered mb-3">
                        <li class="list-group-item">
                            <b>Стать</b> <a class="float-right">{{ $parent->sex }}</a>
                        </li>
                        <li class="list-group-item">
                            <b>День народження</b> <a class="float-right">{{ $parent->birthday }}</a>
                        </li>
                        <li class="list-group-item">
                            <b>Creation Date</b> <a class="float-right">{{$parent->created_at}}</a>
                        </li>
                    </ul>

                    <a href="{{route('parents.edit', ["parent" => $parent->id])}}" class="btn btn-primary btn-block"><b>Edit</b></a>
                </div>
            </div>
        </div>
    </div>
@stop

@section('js')
@stop